package com.mikroe.blepclick;

import android.bluetooth.BluetoothDevice;
import java.util.HashMap;
import java.util.UUID;

/**
 * Created by Rega on 23.7.2014.
 */

public class Blep{

    public static final String _NAME = "BLEP_CLICK";
    public static final String _ADRR = "D9:3E:52:9D:C8:8C";

    public static boolean _AVAILABLE = false;
    public static boolean _CONN_STATE = false;

    public static BluetoothDevice Device = null;


    public static byte txBuffer[];

    //global cmds from android
    public static final int CMD_GET  = 0x50;


    public static String BLEP_SERVICE = "6e400001-b5a3-f393-e0a9-e50e24dcca9e";                     //
    public static String CLIENT_CHARACTERISTIC_CONFIG = "00002902-0000-1000-8000-00805f9b34fb";
    public static String nRF_TX = "6e400002-b5a3-f393-e0a9-e50e24dcca9e";
    public static String nRF_RX = "6e400003-b5a3-f393-e0a9-e50e24dcca9e";
    public static String nRF_RX_Unknown1 = "6e400004-b5a3-f393-e0a9-e50e24dcca9e";
    public static String nRF_RX_Unknown2 = "6e400005-b5a3-f393-e0a9-e50e24dcca9e";


    /* String attributes
    private static HashMap<String, String> attributes = new HashMap();
    static {
        // Sample Services and Characteristics
        attributes.put("00001800-0000-1000-8000-00805f9b34fb", "Generic Access Service");
        attributes.put("00002a00-0000-1000-8000-00805f9b34fb", "Device Name");
        attributes.put("00002a01-0000-1000-8000-00805f9b34fb", "Appearance");
        attributes.put("00002a04-0000-1000-8000-00805f9b34fb", "Peripheral Conn. Parameters");
        attributes.put("00001801-0000-1000-8000-00805f9b34fb", "Generic Attribute Service");
        //UART Over nRF-8001
        attributes.put("6e400001-b5a3-f393-e0a9-e50e24dcca9e", "BLEP Service");
        attributes.put("6e400002-b5a3-f393-e0a9-e50e24dcca9e", "BLEP Characteristic 1"); //Tx
        attributes.put("6e400003-b5a3-f393-e0a9-e50e24dcca9e", "BLEP Characteristic 2"); //Rx
        attributes.put("6e400004-b5a3-f393-e0a9-e50e24dcca9e", "BLEP Characteristic 3"); //
        attributes.put("6e400005-b5a3-f393-e0a9-e50e24dcca9e", "BLEP Characteristic 4"); //

    }
    */


    //BLEP UUID
    public static final UUID UUID_BLEP_SERVICE = UUID.fromString(BLEP_SERVICE);
    public static final UUID UUID_nRF_TX = new UUID(UUID.fromString(nRF_TX).getMostSignificantBits(),
            UUID.fromString(nRF_TX).getLeastSignificantBits());
    public static final UUID UUID_nRF_RX = new UUID(UUID.fromString(nRF_RX).getMostSignificantBits(),
            UUID.fromString(nRF_RX).getLeastSignificantBits());
    public static final UUID UUID_nRF_RX_Un1 = new UUID(UUID.fromString(nRF_RX_Unknown1).getMostSignificantBits(),
            UUID.fromString(nRF_RX_Unknown1).getLeastSignificantBits());
    public static final UUID UUID_nRF_RX_Un2 = new UUID(UUID.fromString(nRF_RX_Unknown2).getMostSignificantBits(),
            UUID.fromString(nRF_RX_Unknown2).getLeastSignificantBits());
    public static final UUID  UUID_CLIENT_CHARACTERISTIC_CONFIG = new UUID(UUID.fromString(CLIENT_CHARACTERISTIC_CONFIG).getMostSignificantBits(),
            UUID.fromString(CLIENT_CHARACTERISTIC_CONFIG).getLeastSignificantBits());


    private static HashMap<UUID, String> attributes = new HashMap<UUID, String>();
    static {
        attributes.put(UUID_BLEP_SERVICE, "BLEP Service");
        attributes.put(UUID_nRF_TX, "BLEP Characteristic 1"); //nRF_RX_TX
        attributes.put(UUID_nRF_RX, "BLEP Characteristic 2"); //
        attributes.put(UUID_nRF_RX_Un1, "BLEP Characteristic 3"); //
        attributes.put(UUID_nRF_RX_Un2, "BLEP Characteristic 4"); //
    }

    public static String lookup(UUID uuid, String defaultName) {
        String name = attributes.get(uuid);
        return name == null ? defaultName : name;
    }


    //public static int HalfToInt(int UINT16) {

    //}

}
